## lomiri 0.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.0)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

project(lomiri VERSION 0.2.1 LANGUAGES C CXX)

set(SHELL_APP lomiri)
set(INDICATORS_CLIENT_APP indicators-client)
set(GREETER_APP lomiri-greeter)

set (DESKTOP_FILE_SHELL "${SHELL_APP}.desktop")
set (DESKTOP_FILE_GREETER "${GREETER_APP}.desktop")
set (DESKTOP_FILE_INDICATORSCLIENT "${INDICATORS_CLIENT_APP}.desktop")
set(QML_DEBUG OFF CACHE BOOL "Enable Qml Debugging")

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Instruct CMake to run moc and rcc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

# enable QML debugging
if(QML_DEBUG)
    add_definitions(-DQT_QML_DEBUG)
endif()

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
  ENABLE_COVERAGE_REPORT(TARGETS ${SHELL_APP} FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

find_package (ECM 1.7.0 QUIET NO_MODULE)
if (ECM_FOUND)
    # Provides us with -DECM_ENABLE_SANITIZERS='X'
    # Where X can be address, thread, memory, leak, undefined
    include("${ECM_MODULE_DIR}/ECMEnableSanitizers.cmake")
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0.0")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override" )
  endif()
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks
add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                       ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)

include(FindPkgConfig)
find_package(Qt5Core 5.6 REQUIRED)
find_package(Qt5Qml 5.6 REQUIRED)
find_package(Qt5Quick 5.6 REQUIRED)
find_package(Qt5Gui 5.6 REQUIRED)
find_package(Qt5DBus 5.6 REQUIRED)
find_package(Qt5Concurrent 5.6 REQUIRED)
find_package(Qt5Sql 5.6 REQUIRED)
find_package(Qt5Test 5.6 REQUIRED)
find_package(Qt5Svg 5.6 REQUIRED)
find_package(Qt5Network 5.6 REQUIRED)
find_package(Qt5Xml 5.6 REQUIRED)
find_package(Intl REQUIRED)

pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=28)
pkg_check_modules(QTMIRSERVER REQUIRED qtmirserver>=0.6.0)
pkg_check_modules(GEONAMES REQUIRED geonames>=0.2)
pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.32)
pkg_check_modules(LAUNCHER_API REQUIRED lomiri-shell-launcher=13)
pkg_check_modules(QMENUMODEL REQUIRED qmenumodel)
pkg_check_modules(GD3 REQUIRED gnome-desktop-3.0)
# 0.1.5 adds lal-application-end.target.
pkg_check_modules(UAL REQUIRED lomiri-app-launch-0>=0.1.5)
pkg_check_modules(LOMIRIGESTURES REQUIRED LomiriGestures)
pkg_check_modules(MIRAL REQUIRED miral)
pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)
pkg_check_modules(LOMIRISCHEMA REQUIRED lomiri-schemas>=0.1.4)

if (QTMIRSERVER_VERSION VERSION_GREATER_EQUAL 0.8.0)
    message("Bulding with miroil")
    pkg_check_modules(MIROIL REQUIRED miroil)
    add_definitions(-DUSE_MIROIL=1)
else()
    message("Bulding without miroil")
endif()

### Check LomiriGestures private headers. No pkg-config (.pc) file is provided for them
find_path(LOMIRIGESTUREPRIV
    NAMES LomiriGestures/private/damper_p.h LomiriGestures/private/ucswipearea_p.h LomiriGestures/private/ucswipearea_p_p.h
    PATHS ${LOMIRIGESTURES_INCLUDEDIR}/LomiriGestures/${LOMIRIGESTURES_VERSION}
    NO_DEFAULT_PATH)
if (${LOMIRIGESTUREPRIV} STREQUAL LOMIRIGESTUREPRIV-NOTFOUND)
   message(FATAL_ERROR "LomiriGestures private headers not found.")
endif()
# end of LomiriGesture private headers check

# Standard install paths
include(GNUInstallDirs)

set(SHELL_APP_DIR ${CMAKE_INSTALL_DATADIR}/lomiri)
set(SHELL_PRIVATE_LIBDIR ${CMAKE_INSTALL_LIBDIR}/lomiri)
set(SHELL_PRIVATE_LIBEXECDIR ${CMAKE_INSTALL_LIBEXECDIR}/lomiri)

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugin_private_module_dir LomiriSystemSettings OUTPUT_VARIABLE USS_PRIVATE_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(USS_PRIVATE_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine USS private plugin installation dir.")
endif()

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir_suffix lomiri-shell-api OUTPUT_VARIABLE SHELL_INSTALL_QML OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_INSTALL_QML STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin installation dir.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir lomiri-shell-api OUTPUT_VARIABLE SHELL_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin import dir.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive -pedantic -Wall -Wextra")

set (CMAKE_CXX_STANDARD 17)

if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

# gtk and lomiri-core (actually sigc++) do not like Qt defining macros named
# "signals" and "slots"
add_definitions(-DQT_NO_KEYWORDS)

# Save a few container detach and conversions
add_definitions(-DQT_STRICT_ITERATORS)

# Use the fast string builder
add_definitions(-DQT_USE_QSTRINGBUILDER)

# Autopilot tests
include(autopilot)
declare_autopilot_test(shell lomiri.shell ${CMAKE_SOURCE_DIR}/tests/autopilot/)

set(MOCK_INDICATOR_SERVICE_APP lomiri-mock-indicator-service)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
    ${APPLICATION_API_INCLUDE_DIRS}
)

# Quiet logger
set(QUIET_LOGGER OFF CACHE BOOL "Disable test output on stdout.")
if(NOT QUIET_LOGGER)
    set(STDOUT_LOGGER "-o" "-,txt")
endif()

execute_process(COMMAND dpkg-architecture -qDEB_HOST_ARCH OUTPUT_VARIABLE ARCH)
if (NOT ARCH MATCHES "arm*")
    set(ENABLE_TOUCH_EMULATION true)
    add_definitions(-DLOMIRI_ENABLE_TOUCH_EMULATION)
    pkg_check_modules(MOUSETOUCHADAPTOR_LIBS REQUIRED x11 xcb xi)
else()
    set(ENABLE_TOUCH_EMULATION false)
    message(STATUS "Touch emulation support disabled.")
endif()

# add subdirectories to build
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(qml)

# Tests
set(NO_TESTS OFF CACHE BOOL "Disable tests.")
if (NOT NO_TESTS)
    pkg_check_modules(QTDBUSTEST REQUIRED
        libqtdbustest-1
        libqtdbusmock-1
        )
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
else()
    message(STATUS "Tests disabled")
endif()

set(DISPLAYED_DISTRO_NAME "" CACHE STRING
    "The distro name displayed in first-run wizard and other places. If not set, will read /etc/os-release")
add_subdirectory(plugins)

#
# Data files
#
add_subdirectory(data)

#
# Translation
#
add_subdirectory(po)

#
# Documentation
#
add_subdirectory(doc)

=== doc/CMakeLists.txt ===
#
# Documentation
#

find_package(Doxygen)
find_program(DOT_EXECUTABLE dot /usr/bin)
find_program(DOXYQML_EXECUTABLE doxyqml /usr/bin)
if (NOT DOXYGEN_FOUND OR NOT DOT_EXECUTABLE OR NOT DOXYQML_EXECUTABLE)
    message(WARNING "Cannot generate documentation: doxygen, doxyqml and/or graphviz not found")
else()
    file(GLOB_RECURSE DOC_FILES
        ${CMAKE_BINARY_DIR}/include/*.h
        ${CMAKE_SOURCE_DIR}/include/*.h
        ${CMAKE_SOURCE_DIR}/src/*.h
        ${CMAKE_SOURCE_DIR}/src/*.cpp
        ${CMAKE_SOURCE_DIR}/plugins/*.h
        ${CMAKE_SOURCE_DIR}/plugins/*.cpp
        ${CMAKE_SOURCE_DIR}/plugins/*.qml
        ${CMAKE_SOURCE_DIR}/plugins/*.js
        ${CMAKE_SOURCE_DIR}/qml/*.qml
        ${CMAKE_SOURCE_DIR}/qml/*.js
        ${CMAKE_SOURCE_DIR}/tests/autopilot/*.py
        ${CMAKE_SOURCE_DIR}/tests/utils/*.h
        ${CMAKE_SOURCE_DIR}/tests/utils/*.cpp
        ${CMAKE_SOURCE_DIR}/tests/utils/*.qml
        ${CMAKE_SOURCE_DIR}/tests/utils/*.js
        ${CMAKE_SOURCE_DIR}/tests/autopilot/lomiri/shell/emulators/*.py
        ${CMAKE_SOURCE_DIR}/tests/autopilot/lomiri/process_helpers.py)

    string(REPLACE ";" " " DOXYGEN_INPUT "${DOC_FILES}")

    configure_file(${PROJECT_SOURCE_DIR}/doc/Doxyfile.in ${PROJECT_BINARY_DIR}/doc/Doxyfile @ONLY IMMEDIATE)
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/doc/html/index.html
                       COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_BINARY_DIR}/doc/Doxyfile
                       DEPENDS ${PROJECT_BINARY_DIR}/doc/Doxyfile ${DOC_FILES})
    add_custom_target(doc DEPENDS ${PROJECT_BINARY_DIR}/doc/html/index.html)
    install(DIRECTORY ${PROJECT_BINARY_DIR}/doc/html
            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/${PROJECT_NAME}
            OPTIONAL)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(liblomiri-private)

pkg_check_modules(CONNECTIVITY REQUIRED lomiri-connectivity-qt1)
pkg_check_modules(GSETTINGS_QT REQUIRED gsettings-qt)

include_directories(
    SYSTEM
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
    ${GSETTINGS_QT_INCLUDE_DIRS}
    ${CONNECTIVITY_INCLUDE_DIRS}
    ${QTMIRSERVER_INCLUDE_DIRS}
    ${MIROIL_INCLUDE_DIRS}
)

include_directories(
    ${liblomiri-private_SOURCE_DIR}
)

file(GLOB_RECURSE QML_FILES
    ${CMAKE_SOURCE_DIR}/qml/*
    ${CMAKE_SOURCE_DIR}/tests/*.qml
    ${CMAKE_SOURCE_DIR}/tests/*.js
    ${CMAKE_SOURCE_DIR}/tests/*.jpg
    ${CMAKE_SOURCE_DIR}/tests/*.png
    ${CMAKE_SOURCE_DIR}/tests/*.sci
    ${CMAKE_SOURCE_DIR}/tests/*.svg
)

set(SOURCE_FILES
    ApplicationArguments.cpp
    main.cpp
    CachingNetworkManagerFactory.cpp
    DisplayConfigurationStorage.cpp
    LomiriApplication.cpp
    LomiriCommandLineParser.cpp
    UnixSignalHandler.cpp
    DebuggingController.cpp
    WindowManagementPolicy.cpp
    ${QML_FILES} # This is to make qml and image files appear in the IDE's project tree
)

if (ENABLE_TOUCH_EMULATION)
    set(SOURCE_FILES ${SOURCE_FILES} MouseTouchAdaptor.cpp)
endif()

pkg_check_modules(SYSTEMD REQUIRED libsystemd)

include_directories(
    ${SYSTEMD_INCLUDE_DIRS}
)

add_executable(${SHELL_APP} ${SOURCE_FILES})

target_link_libraries(${SHELL_APP}
    Qt5::DBus Qt5::Gui Qt5::Qml Qt5::Quick Qt5::Test
    ${GSETTINGS_QT_LDFLAGS}
    ${QTMIRSERVER_LDFLAGS}
    ${SYSTEMD_LDFLAGS}
    ${Intl_LIBRARIES}
    ${MIROIL_LDFLAGS}
    LomiriGestures
    lomiri-connectivity-qt1
    lomiri-private
)

if (ENABLE_TOUCH_EMULATION)
    target_link_libraries(${SHELL_APP} ${MOUSETOUCHADAPTOR_LIBS_LDFLAGS})
endif()

# install binaries
install(TARGETS ${SHELL_APP}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     )

=== tests/CMakeLists.txt ===
include(QmlTest)

# QML tests that do not require graphical capabilities.
add_meta_test(unittests)

# QML tests that require graphical capabilities.
add_meta_test(uitests)
add_meta_test(xvfbuitests)

# Run our meta-meta tests serially because we don't need to nest
# parallelized tests.
add_meta_test(alltests SERIAL DEPENDS unittests uitests)
add_meta_test(xvfballtests SERIAL DEPENDS unittests xvfbuitests)

# Support libraries and plugins
add_subdirectory(mocks)
add_subdirectory(utils)
add_subdirectory(uqmlscene)

# Use our custom implementation of qmlscene and import dbus-test-runner
add_executable(qmlscene ALIAS uqmlscene)
import_executables(dbus-test-runner)
import_executables(qdbus-simple-test-runner)

set(LOMIRI_PLUGINPATH "${CMAKE_BINARY_DIR}/plugins" CACHE PATH "Path to pre-built lomiri plugin dir.")
set(LOMIRI_MOCKPATH "${CMAKE_BINARY_DIR}/tests/mocks" CACHE PATH "Path to pre-built lomiri mock dir.")

# Pre-built mocks have preference, pre-built plugins replace local build
set(LOMIRI_IMPORT_PATHS
    ${LOMIRI_MOCKPATH}
    ${CMAKE_BINARY_DIR}/tests/mocks
    ${CMAKE_BINARY_DIR}/tests/utils/modules
    ${LOMIRI_PLUGINPATH}
)
list(REMOVE_DUPLICATES LOMIRI_IMPORT_PATHS)
set(LOMIRI_IMPORT_PATHS ${LOMIRI_IMPORT_PATHS} CACHE INTERNAL "")

macro(lomiri_parse_arguments)
    cmake_parse_arguments(U8TEST
        "${QMLTEST_OPTIONS}"
        "${QMLTEST_SINGLE}"
        "${QMLTEST_MULTI}"
        ${ARGN}
    )

    set(ld_paths)
    list(APPEND ld_paths
        ${LOMIRI_MOCKPATH}/liblightdm
        ${LOMIRI_MOCKPATH}/libusermetrics
        ${LOMIRI_MOCKPATH}/WindowManager
    )

    string(REPLACE ";" ":" ld_library_path "${ld_paths}")
    set(ld_library_path LD_LIBRARY_PATH=${ld_library_path})

    set(U8TEST_ARGN "${ARGN}")

    set(environment
        LOMIRI_TESTING=1
        LANGUAGE=C
        LC_ALL=C.UTF-8
        ${ld_library_path}
    )
endmacro()


# add a non-graphical unit test
# see QmlTest.cmake for additional options
function(add_lomiri_unittest COMPONENT_NAME TARGET)
    lomiri_parse_arguments(${ARGN})
    add_executable_test(${COMPONENT_NAME} ${TARGET}
        ADD_TEST
        IMPORT_PATHS ${LOMIRI_IMPORT_PATHS}
        TARGETS unittests
        ${U8TEST_ARGN}
        ENVIRONMENT ${environment}
                    ${U8TEST_ENVIRONMENT}
                    QT_QPA_PLATFORM=minimal
                    UITK_ICON_THEME=suru
    )
endfunction()

# add a graphical unit test
function(add_lomiri_uitest COMPONENT_NAME TARGET)
    lomiri_parse_arguments(${ARGN})
    add_executable_test(${COMPONENT_NAME} ${TARGET}
        IMPORT_PATHS ${LOMIRI_IMPORT_PATHS}
        TARGETS uitests
        ${U8TEST_ARGN}
        ENVIRONMENT ${environment}
                    ${U8TEST_ENVIRONMENT}
                    UITK_ICON_THEME=suru
    )
endfunction()

# add a non-graphical qml unit test
function(add_lomiri_qmlunittest PATH COMPONENT_NAME)
    lomiri_parse_arguments(${ARGN})
    add_qml_unittest(${PATH} ${COMPONENT_NAME}
        ADD_TEST
        IMPORT_PATHS ${LOMIRI_IMPORT_PATHS}
        TARGET unittests
        ${U8TEST_ARGN}
        ENVIRONMENT ${environment}
                    ${U8TEST_ENVIRONMENT}
                    QT_QPA_PLATFORM=minimal
                    UITK_ICON_THEME=suru
    )
endfunction()

# add a graphical qml test
function(add_lomiri_qmltest PATH COMPONENT_NAME)
    lomiri_parse_arguments(${ARGN})
    add_qml_test(${PATH} ${COMPONENT_NAME}
        IMPORT_PATHS ${LOMIRI_IMPORT_PATHS}
        TARGETS uitests
        ${U8TEST_ARGN}
        ENVIRONMENT ${environment}
                    ${U8TEST_ENVIRONMENT}
                    UITK_ICON_THEME=suru
    )
endfunction()

# add a graphical qml benchmark
function(add_lomiri_qmlbenchmark PATH COMPONENT_NAME ITERATIONS)
    add_lomiri_qmltest(${PATH} ${COMPONENT_NAME} ITERATIONS ${ITERATIONS} ${ARGN})
endfunction()

# add files needed for qml tests, just here for better alignment with add_lomiri_qmltest
function(add_lomiri_qmltest_data PATH COMPONENT_NAME)
    add_qml_test_data("${PATH}" "${COMPONENT_NAME}")
endfunction()

# used to make dbus adaptor classes from xml to mock system services
if(DEFINED ENV{DEB_BUILD_MULTIARCH})
  set(QDBUSXML2CPP_EXECUTABLE "/usr/lib/$ENV{DEB_BUILD_MULTIARCH}/qt5/bin/qdbusxml2cpp")
else()
  FIND_PROGRAM(QDBUSXML2CPP_EXECUTABLE qdbusxml2cpp)
endif()

if(NOT QDBUSXML2CPP_EXECUTABLE)
    message(FATAL_ERROR "qdbusxml2cpp not found")
endif()

install(DIRECTORY data graphics
    DESTINATION "${SHELL_APP_DIR}/tests"
)


# Actual test definitions
add_subdirectory(plugins)
add_subdirectory(qmltests)
add_subdirectory(whitespace)
add_subdirectory(imports)
add_subdirectory(copyright)

=== tools/CMakeLists.txt ===
add_subdirectory(indicatorsclient)
add_subdirectory(menutool)

install(FILES unlock-device DESTINATION ${SHELL_APP_DIR})

=== plugins/AccountsService/CMakeLists.txt ===
add_definitions(-DSM_BUSNAME=systemBus)
include_directories(${GLIB_INCLUDE_DIRS})

add_library(AccountsService-qml MODULE
    AccountsService.cpp
    AccountsServiceDBusAdaptor.cpp
    plugin.cpp
    )

target_link_libraries(AccountsService-qml
    Qt5::DBus Qt5::Qml
    ${GLIB_LIBRARIES}
    )

add_lomiri_plugin(AccountsService 0.1 AccountsService TARGETS AccountsService-qml)

set(DBUS_IFACE_DIR "${CMAKE_INSTALL_PREFIX}/share/dbus-1/interfaces")
set(ACCOUNTS_IFACE_DIR "${CMAKE_INSTALL_PREFIX}/share/accountsservice/interfaces")

install(FILES com.lomiri.shell.AccountsService.xml
        DESTINATION "${DBUS_IFACE_DIR}"
    )

# Create accountsservice symlink for above dbus interface
install(CODE "
execute_process(COMMAND mkdir -p \"\$ENV{DESTDIR}${ACCOUNTS_IFACE_DIR}\")
execute_process(COMMAND ln -sf ../../dbus-1/interfaces/com.lomiri.shell.AccountsService.xml \"\$ENV{DESTDIR}${ACCOUNTS_IFACE_DIR}\")
    ")

=== plugins/ProcessControl/CMakeLists.txt ===
add_definitions(-DSM_BUSNAME=sessionBus)

add_library(ProcessControl-qml MODULE
    LocationWatcher.cpp
    ProcessControl.cpp
    plugin.cpp
)

target_link_libraries(ProcessControl-qml
    Qt5::DBus Qt5::Qml
)

target_include_directories(ProcessControl-qml PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

add_lomiri_plugin(ProcessControl 0.1 ProcessControl TARGETS ProcessControl-qml)

set(DBUS_IFACE_DIR "${CMAKE_INSTALL_PREFIX}/share/dbus-1/interfaces")

install(FILES com.lomiri.ProcessControl.xml
    DESTINATION "${DBUS_IFACE_DIR}"
)

=== plugins/UInput/CMakeLists.txt ===
add_library(UInput-qml MODULE
    plugin.cpp
    uinput.cpp
)

target_link_libraries(UInput-qml Qt5::Qml)
add_lomiri_plugin(UInput 0.1 UInput TARGETS UInput-qml)

=== plugins/Wizard/CMakeLists.txt ===
pkg_search_module(GD3 REQUIRED gnome-desktop-3.0)

include_directories(SYSTEM ${GD3_INCLUDE_DIRS} ${GLIB_INCLUDE_DIRS} ${GEONAMES_INCLUDE_DIRS})

add_library(Wizard-qml MODULE
    plugin.cpp
    PageList.cpp
    System.cpp
    LocalePlugin.cpp
    timezonemodel.cpp
    Status.cpp
    keyboardLayoutsModel.cpp
    Changelog.cpp
)

target_link_libraries(Wizard-qml
    Qt5::DBus Qt5::Qml
    ${GD3_LDFLAGS} ${GLIB_LDFLAGS} ${GEONAMES_LDFLAGS}
)

if (NOT "${DISPLAYED_DISTRO_NAME}" STREQUAL "")
    target_compile_definitions(Wizard-qml PRIVATE
        -DLOMIRI_DISPLAYED_DISTRO_NAME="${DISPLAYED_DISTRO_NAME}")
endif ()

add_lomiri_plugin(Wizard 0.1 Wizard TARGETS Wizard-qml)

set(POLKIT_LIB_DIR "${CMAKE_INSTALL_LOCALSTATEDIR}/lib/polkit-1")
install(FILES 50-com.lomiri.wizard.pkla DESTINATION ${POLKIT_LIB_DIR}/localauthority/10-vendor.d)

=== tests/mocks/CMakeLists.txt ===
find_package(QmlPlugins)

# Set up and optionally install a mock plugin for lomiri.
#
# add_lomiri_mock(plugin version path
#     [PREFIX string]  # Install the plugin to the specified prefix under lomiri private plugin directory
#     [...]            # See export_qmlfiles and export_qmlplugin documentation for more options
# )

macro(add_lomiri_mock PLUGIN VERSION PATH)
    set(single PREFIX)
    cmake_parse_arguments(MOCK "" "${single}" "" ${ARGN})

    if (NOT MOCK_PREFIX)
        set(MOCK_PREFIX mocks)
    endif()

    export_qmlfiles(${PLUGIN} ${PATH}
        DESTINATION ${SHELL_INSTALL_QML}/${MOCK_PREFIX}
        TARGET_PREFIX ${MOCK_PREFIX}-Mock
        ${MOCK_UNPARSED_ARGUMENTS}
    )
    export_qmlplugin(${PLUGIN} ${VERSION} ${PATH}
        DESTINATION ${SHELL_INSTALL_QML}/${MOCK_PREFIX}
        TARGET_PREFIX ${MOCK_PREFIX}-Mock
        ${MOCK_UNPARSED_ARGUMENTS}
    )
endmacro()

add_subdirectory(AccountsService)
add_subdirectory(Biometryd)
add_subdirectory(Cursor)
add_subdirectory(GSettings.1.0)
add_subdirectory(indicator-service)
add_subdirectory(liblightdm)
add_subdirectory(libusermetrics)
add_subdirectory(LightDMController)
add_subdirectory(Hfd)
add_subdirectory(MeeGo)
add_subdirectory(Powerd)
add_subdirectory(QMenuModel.1)
add_subdirectory(SessionBroadcast)
add_subdirectory(Lomiri)
add_subdirectory(QtMir/Application)
add_subdirectory(QtMultimedia)
add_subdirectory(WindowManager)
add_subdirectory(Wizard)
add_subdirectory(Utils)
add_subdirectory(UInput)

install(
  DIRECTORY data
  DESTINATION ${SHELL_APP_DIR}/mocks
)

=== tests/qmltests/CMakeLists.txt ===
add_subdirectory(Components)

add_lomiri_qmltest(. OrientedShell)
add_lomiri_qmltest(. DisabledScreenNotice)
add_lomiri_qmltest(. Shell)
add_lomiri_qmltest(. ShellWithPin)
add_lomiri_qmltest(. ShellWithPinClock)
add_lomiri_qmltest(. DeviceConfiguration)
add_lomiri_qmltest_data(. EdgeBarrierControls)
add_lomiri_qmltest_data(. ApplicationMenuDataLoader)
add_lomiri_qmltest(ApplicationMenus MenuBar)
add_lomiri_qmltest(ApplicationMenus MenuPopup)
add_lomiri_qmltest(Components Background)
add_lomiri_qmltest(Components Dialogs)
add_lomiri_qmltest(Components DraggingArea)
add_lomiri_qmltest(Components LazyImage)
add_lomiri_qmltest_data(Components tst_LazyImage)
add_lomiri_qmltest(Components Lockscreen)
add_lomiri_qmltest(Components ModeSwitchWarningDialog)
add_lomiri_qmltest(Components PhysicalKeysMapper)
add_lomiri_qmltest(Components Rating)
add_lomiri_qmltest(Components SharingPicker)
add_lomiri_qmltest(Components Showable)
add_lomiri_qmltest(Components VirtualTouchPad)
add_lomiri_qmltest(Components Wallpaper)
add_lomiri_qmltest(Components WallpaperResolver)
add_lomiri_qmltest(Components ZoomableImage)
add_lomiri_qmltest(Greeter Clock)
add_lomiri_qmltest(Greeter Greeter)
add_lomiri_qmltest(Greeter Infographics)
add_lomiri_qmltest(Greeter PinCodeClock)
add_lomiri_qmltest(Greeter GreeterView)
add_lomiri_qmltest_data(Greeter TestView)
add_lomiri_qmltest(Launcher Launcher)
add_lomiri_qmltest(Launcher Drawer)
add_lomiri_qmltest(Notifications Notifications)
add_lomiri_qmltest(Notifications VisualSnapDecisionsQueue)
add_lomiri_qmltest(Notifications OptionToggle)
add_lomiri_qmltest(Notifications SwipeToAct)
add_lomiri_qmltest_data(Notifications Notification)
add_lomiri_qmltest(Panel ActiveCallHint)
add_lomiri_qmltest(Panel PanelItemRow)
add_lomiri_qmltest(Panel PanelMenuPage)
add_lomiri_qmltest(Panel PanelBar)
add_lomiri_qmltest(Panel PanelMenu)
add_lomiri_qmltest(Panel MenuContent)
add_lomiri_qmltest(Panel Panel)
add_lomiri_qmltest(Panel PanelSmallScreen)
add_lomiri_qmltest_data(Panel PanelTest)
add_lomiri_qmltest(Panel/Indicators IndicatorItem)
add_lomiri_qmltest(Panel/Indicators IndicatorsLight)
add_lomiri_qmltest(Panel/Indicators IndicatorMenuItemFactory)
add_lomiri_qmltest(Panel/Indicators MessageMenuItemFactory)
add_lomiri_qmltest(Stage ApplicationWindow)
add_lomiri_qmltest(Stage DesktopStage)
add_lomiri_qmltest(Stage PhoneStage)
add_lomiri_qmltest(Stage QMLTopLevelWindowModel)
add_lomiri_qmltest(Stage SurfaceContainer)
add_lomiri_qmltest(Stage TabletStage)
add_lomiri_qmltest(Stage WindowResizeArea)
add_lomiri_qmltest(Stage Splash)
add_lomiri_qmltest(Stage DecoratedWindow)
add_lomiri_qmltest(Stage WindowDecoration)
add_lomiri_qmltest_data(Stage ApplicationCheckBox)
add_lomiri_qmltest_data(Stage SizeHintField)
add_lomiri_qmltest_data(Stage SurfaceManagerControls)
add_lomiri_qmltest_data(Stage SurfaceManagerField)
add_lomiri_qmltest(Tutorial Tutorial)
add_lomiri_qmltest(Wizard Wizard ENVIRONMENT "OXIDE_NO_SANDBOX=1")
add_lomiri_qmltest_data(Wizard licenses)
#add_lomiri_qmltest_data(Wizard nolicenses)
add_lomiri_qmltest(utils/Lomiri/Test LomiriTest)
add_lomiri_qmltest_data(utils/Lomiri/Test MockObjectForInstanceOfTest)
add_lomiri_qmltest_data(utils/Lomiri/Test MockObjectForInstanceOfTestChild)

=== tools/menutool/CMakeLists.txt ===
add_executable(menutool
    menutool.cpp
    )

target_link_libraries(menutool Qt5::Qml Qt5::Quick)

=== debian/changelog ===
lomiri (0.2.1-11) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/control:
    + Add additional B-Ds required for unit tests.
    + Bump versioned D on lomiri-system-settings to (>= 1.1.0-3~). This
      version is the first version supporting the non-Ubuntu AccountsService
      settings for the shell's background image.
  * debian/rules:
    + Provide test home in test bed.
    + Set DISPLAYED_DISTRO_NAME build options to enable Lomiri wizard on
      initial session login.
    + Make tests fail the build on architectures we have not tagged as flaky.
      (Let's see...).
  * debian/patches:
    + Add 2011_skip-language-keymap-tests.patch. Skip unit test requiring
      Ubuntu-specific AccountsService.
    + Add 1012_no-whitespace-checks-in-debian-folder.patch. Don't run whitespace
      checks in non-upstream folders (i.e. debian/).
    + Add 1013_fix-copyright-tests.patch. Add missing copyright headers, fix
      check_copyright.sh.
    + Add 2007_fix-testWindowStateStorage.patch. Adjust HOME env var for
      building lomiri as a Debian package.
    + Add 2008_skip-failing-tests.patch. Skip failing unit tests.
    + Add 2009_disable-qtmir-tests.patch. Disable qtmir-based unit tests. They
      currently fail with Mir 2.x.
    + Add 0016_support-vendor-accountsservice-interface.patch. Support non-
      Ubuntu AccountsService for configuring the shell's background image.
    + Add 1014_fix-test-AccountsService-interfaces-xml.patch. Fix annotation in
      tests/plugins/AccountsService/interfaces.xml.
    + Add 1015_Meego-Ofono.patch. Adjust to libqofono namespace change since
      libqofono 0.117.
    + Rename disable-broken-test-mir2.patch to 2001_disable-broken-test-
      mir2.patch.
  * debian/lomiri-tests.lintian-overrides:
    + Comment-out temporarily unused overrides.
  * debian/lomiri-common.lintian-overrides:
    + Drop file. The appstream-metadata-missing-modalias-provide override is
      not triggered anymore.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 22 Apr 2024 09:39:47 +0200

lomiri (0.2.1-10) unstable; urgency=medium

  * debian/patches:
    + Add 0015_qml-Stage-Adopt-use-of-transform-for-scaling-the-
      MirSurfaceItem.patch. qml/Stage: Adopt use of transform for scaling
      the MirSurfaceItem.
    + Add 2006_use-Noto-Sans-Font.patch. Use Noto Sans instead of Ubuntu
      font in indicator tray.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 25 Mar 2024 11:19:05 +0100

lomiri (0.2.1-9) unstable; urgency=medium

  * debian/control:
    + Add to R: (lomiri): lomiri-polkit-agent.
    + Assure that lomiri-greeter also removes arctica-greeter-guest-session and
      arctica-greeter-remote-logon if it gets installed.
    + Assure lomiri-schemas >= 0.1.4-2~ in D: and B-D:.
  * debian/patches:
    + Add 1001_use-com-lomiri-Shell-pictureUri.patch. Use new
      com.lomiri.Shell(.Greeter) gsetting 'background-picture-uri' for override
      hard-coded background image.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 09 Mar 2024 16:17:41 +0100

lomiri (0.2.1-8) unstable; urgency=medium

  * debian/patches:
    + Add 1009_fix-default-wallpaper-filename.patch. Use generic wallpaper name
      as default wallpaper.
    + Renumber 0003_qml-Panel-PanelMenuPage.qml-Drop-work-around-for-QTB.patch
      (-> 0013).
    + Renumber 0004_hide-surface-less-app-icons-in-launcher.patch (-> 0014).
    + Cherry-pick patch 0004-0011 from lomiri upstream MR-133 (desktop-mode
      improvements).
    + Add 0021_set-z-index-of-spread-to-current-number-of-apps.patch. Set
      z-index of Spread to current number of apps. Fixes when one opens a lot
      of apps (10+), the apps on the right end of the App Spread won't be
      flickable anymore.
    + Add 0022_enable-stopping-the-flick-with-just-a-press.patch. Enable
      stopping the flick with just a press.
    + Add 0023_fix-build-on-32bit-arches-with-64bit-time-t.patch. Fix build
      on 32bit arches with 64bit time_t.
    + Add 0024_only-load-prompty-if-cover-page-is-not-shown.patch. Reset the
      password field so that passwords previously entered (but not used) before
      lock screen kicks once more gets removed and is not usable anymore by a
      potential attacker.
  * debian/control:
    + Drop from B-D: gdb.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 08 Mar 2024 10:49:31 +0100

lomiri (0.2.1-7) unstable; urgency=medium

  * debian/patches:
    + Add 0004_hide-surface-less-app-icons-in-launcher.patch. Hide icons from
      launcher if they don't show anything on screen (such as Xwayland, xdg-
      portal, etc.).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 27 Feb 2024 23:08:45 +0100

lomiri (0.2.1-6) unstable; urgency=medium

  * debian/patches:
    + Add 0003_qml-Panel-PanelMenuPage.qml-Drop-work-around-for-QTB.patch.
      Reduce massive syslog spamming.
    + Typo fix in patch header of 1005_cursor-always-follow-cursor-position
      from-mir.patch.
  * debian/:
    + Add 90-default-session-lomiri.conf and install into lomiri-greeter
      bin:pkg to override lightdm-xsession as default login session.
  * debian/control:
    + Switch from pkg-config to pkgconf. Thanks, lintian.
  * debian/copyright:
    + Update copyright attribution for debian/.
  * debian/liblomiri-private0.lintian-overrides:
    + Add link-to-shared-library-in-wrong-package override.
  * debian/lomiri-common.lintian-overrides:
    + Update path in appstream-metadata-missing-modalias-provide override.
  * debian/lomiri.lintian-overrides:
    + Drop no-manual-page overrides for executables in /usr/libexec/.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 26 Feb 2024 16:11:50 +0100

lomiri (0.2.1-5) unstable; urgency=medium

  [ Alfred Neumayer ]
  * debian/patches:
    + Add 0001_displayconfigurationstorage-fix-typo.patch.
      DisplayConfigurationStorage: Fix typo.
    + Add 0002_qml-shell-hide-and-disallow-launcher-in-greeter-only-mode.patch.


=== debian/control ===
Source: lomiri
Section: x11
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Build-Depends:
 cmake,
 cmake-extras,
 dbus-test-runner,
 debhelper-compat (= 13),
 dh-apparmor,
 doxyqml,
 graphviz,
 lomiri-schemas (>= 0.1.4-2~),
 libdeviceinfo-dev,
 libevdev-dev,
 libgeonames-dev (>= 0.2),
 libgl-dev[!arm64 !armhf],
 libgl1-mesa-dri,
 libgles2-mesa-dev[arm64 armhf],
 libglib2.0-dev,
 libgnome-desktop-3-dev,
 libgsettings-qt-dev,
 liblightdm-qt5-3-dev,
 liblomiri-connectivity-qt1-dev,
 libpam0g-dev,
 libpulse-dev,
 libqmenumodel-dev (>= 0.2.12),
 libqtmirserver-dev (>= 0.8.0~git20230223.bd21224-3~),
 libmiroil-dev,
 libmiral-dev,
 libqt5sql5-sqlite,
 libqt5svg5-dev,
 libqt5xmlpatterns5-dev,
 libqtdbusmock1-dev (>= 0.7),
 libqtdbustest1-dev,
 libsystemd-dev [linux-any],
 liblomirisystemsettings-dev,
 liblomiri-app-launch-dev (>= 0.1.5),
 liblomiri-download-manager-common-dev,
 liblomirigestures-dev (>= 1.3.2030),
 liblomirigestures5-private-dev (>= 1.3.2030),
 libudev-dev,
 libldm-common-dev,
 liblomiri-api-dev (>= 0.2.0),
 libusermetricsoutput-dev,
 libx11-dev[!arm64 !armhf],
 libxcb1-dev[!arm64 !armhf],
 libxi-dev[!arm64 !armhf],
 libxcb-dri2-0-dev[!arm64 !armhf],
 licensecheck,
 mir-platform-graphics-x,
 mirtest-dev,
 pkgconf,
 python3-all:any,
 python3-setuptools,
 qml-module-qt-labs-folderlistmodel,
 qml-module-qt-labs-settings,
 qml-module-qtmultimedia (>= 5.6),
 qml-module-qtqml-statemachine,
 qml-module-qtquick-layouts,
 qml-module-qtquick-xmllistmodel,
 qml-module-qtquick2,
 qml-module-qtsysteminfo,
 qml-module-qttest,
 qml-module-lomiri-components (>= 1.3.5000),
 qml-module-lomiri-layouts,
 qml-module-lomiri-settings-components,
 qml-module-lomiri-settings-menus,
 qml-module-lomiri-test,
 qml-module-qtmir,
 qtbase5-dev (>= 5.6),
 qtbase5-dev-tools,
 qtbase5-private-dev (>= 5.6),
 qtdbustest-runner,
 qtdeclarative5-dev (>= 5.6),
 qtdeclarative5-dev-tools,
 qtdeclarative5-private-dev (>= 5.6),
 qml-module-lomiri-content,
 systemd-dev [linux-any],
# fonts-ubuntu,
 xvfb,
 xauth,
# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
 libboost-filesystem-dev,
 libboost-system-dev,
 rdfind,
 symlinks,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri

Package: lomiri-greeter
Architecture: all
Depends:
 lomiri (>= ${source:Version}), lomiri (<< ${source:Version}.1~),
 lightdm,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 arctica-greeter,
 arctica-greeter-guest-session,
 arctica-greeter-remote-logon,
Provides:
 lightdm-greeter,
Description: LightDM Greeter for the Lomiri Operating Environment
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides the Lomiri Greeter.

Package: lomiri
Architecture: any
Provides:
 indicator-renderer,
 notification-daemon
Depends:
 ayatana-indicator-bluetooth,
 ayatana-indicator-datetime,
 ayatana-indicator-display,
 ayatana-indicator-keyboard,
 ayatana-indicator-messages,
 ayatana-indicator-power,
 ayatana-indicator-session,
 ayatana-indicator-sound,
 lomiri-app-launch (>= 0.1.5),
 dmz-cursor-theme,
 gsettings-desktop-schemas,
 libcap2-bin,
 libglib2.0-bin,
 qml-module-biometryd,
 qml-module-lomiri-components,
 qml-module-lomiri-layouts,
 qml-module-lomiri-telephony,
 qml-module-lomiri-settings-menus,
 qml-module-qmenumodel1,
 qml-module-qt-labs-folderlistmodel,
 qml-module-qt-labs-settings,
 qml-module-qtmir (>= 0.4.8),
 qml-module-qtqml-statemachine,
 qml-module-qtquick-xmllistmodel,
 qml-module-qtsysteminfo,
 qml-module-hfd,
 qtmir,
 lomiri-indicator-network,
 lomiri-system-settings (>= 1.1.0-3~),
 lomiri-url-dispatcher,
 lomiri-launcher-impl-13,
 lomiri-common (>= ${source:Version}), lomiri-common (<< ${source:Version}.1~),
 liblomiri-private0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 mir-platform-graphics-gbm-kms | mir-platform-graphics-eglstream-kms | mir-platform-graphics-wayland | mir-platform-graphics-x,
 lomiri-desktop-session | lomiri-touch-session,
 lomiri-greeter,
 lomiri-greeter-session-broadcast,
 lomiri-indicator-transfer,
 lomiri-polkit-agent,
 maliit-keyboard,
Breaks:
 indicator-network (<< 0.5.1+14.10.20141014),
 lomiri-keyboard (<< 0.100),
 lomiri-touch-session (<< 0.107),
 lomiri-scope-tool,
Replaces:
 lomiri-touch-session (<< 0.82~),
 lomiri-scope-tool,
Conflicts:
 lomiri-system-settings-wizard,
Description: Shell of the Lomiri Operating Environment
 Shell of the Lomiri Operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides the Lomiri shell.

Package: lomiri-common
Architecture: all
Depends:
 qml-module-qtquick-layouts,
 qml-module-lomiri-components (>= 1.3.2030) | qml-module-lomiri-components-gles (>= 1.3.2030),
 qml-module-lomiri-settings-components,
 qml-module-lomiri-thumbnailer,
 qtdeclarative5-lomiri-notifications-plugin (>= 0.1.2) | lomiri-notifications-impl,
 qttranslations5-l10n,
 lomiri-application-impl-27,
 lomiri-notifications-impl-3,
 lomiri-schemas (>= 0.1.4-2~),
 lomiri-tests | lomiri-application-impl,
 ${misc:Depends},
Description: Shell of the Lomiri Operating Environment (common files)
 Shell of the Lomiri Operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package contains the QML, graphics and locale files for lomiri.

Package: lomiri-tests
Architecture: any
Multi-Arch: foreign
Depends:
 dbus-test-runner,
 parallel,
 qtdbustest-runner,
 qtdeclarative5-dev-tools,
 lomiri (= ${binary:Version}),
 xauth,
 xvfb,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lomiri-application-impl,
 lomiri-application-impl-27,
 lomiri-fake-env,
Replaces:
 lomiri-autopilot (<< 8.02+15.04.20150422-0lomiri1),
 lomiri-fake-env,
Conflicts:
 lomiri-fake-env,
Description: Scripts and mocks for running Lomiri Shell tests
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides fake implementations of some QML modules used by
 the Lomiri Shell (e.g. Lomiri.Application) so that you can run it in a
 sandboxed environment; it also provides scripts to run its test suite.

Package: liblomiri-private0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 lomiri-schemas (>= 0.1.4-2~),
 qml-module-gsettings1.0,
 qml-module-qtmultimedia,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lomiri-launcher-impl,
 lomiri-launcher-impl-13,
Breaks:
 lomiri-private,
Replaces:
 lomiri-private,
Description: Lomiri Operating Environment's Shell (private libs)
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package contains the private libraries for QML and other components
 only used by the Lomiri Shell.

Package: lomiri-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Lomiri Operating Environment's Shell (documentation files)
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides documentation of the Lomiri Shell.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export NO_PNG_PKG_MANGLE=1
export QT_SELECT=qt5

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Skip tests on the archs they are known to be flaky  with current configuration
testskip_architectures := arm64 powerpc ppc64el s390x

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
export CONFIGURE_FLAGS := -DENABLE_UBUNTU_ACCOUNTSSERVICE=ON
endif

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	# Debian defines CMAKE_INSTALL_LOCALSTATEDIR as /usr/var, which is wrong.
	# So until Debian bug 719148 is fixed, do it ourselves.
	dh_auto_configure -- -DCMAKE_INSTALL_LOCALSTATEDIR="/var" \
	                     -DDISPLAYED_DISTRO_NAME="Debian Lomiri" \
	                     $(CONFIGURE_FLAGS)

override_dh_auto_build:
	# doc is not a default target
	dh_auto_build -- -O all doc

override_dh_auto_test:
	mkdir -p debian/home
	export HOME=debian/home
	# Run the entire test battery
	# Parallel tests have a risk of starting xvfb on the same DISPLAY multiple times,
	# causing the whole battery to fail.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	-dh_auto_test --no-parallel -- -O -k xvfballtests
else
	# FIXME: Temporarily disable unit tests on all other architectures, as well. They
	# seem flaky when built+run on systems more recent than Ubuntu 20.04...
	dh_auto_test --no-parallel -- -O -k xvfballtests
endif
endif

override_dh_fixperms:
	dh_fixperms
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Session/libSessionBackendTestPreload.so || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/abs-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/click-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/click-icon.svg || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/no-name.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/rel-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/rel-icon.svg || true

override_dh_install:
	rm debian/tmp/usr/bin/indicators-client
	rm debian/tmp/usr/share/applications/indicators-client.desktop
	rm debian/tmp/usr/share/lomiri/unlock-device
	rm debian/tmp/usr/lib/systemd/user/*.service
	cd debian/tmp/usr/share/doc/lomiri/html/ && rdfind -makesymlinks true .
	cd debian/tmp/usr/share/doc/lomiri/html/ && symlinks -rc .
	dh_install

override_dh_installdocs:
	dh_installdocs
	# Remove results.txt for reproducible builds
	rm -vf debian/lomiri-doc/usr/share/doc/lomiri/html/results.txt

# use private lib directories
override_dh_makeshlibs:
	dh_makeshlibs -Nlomiri-tests

override_dh_shlibdeps:
	# Some mock libraries link against liblightdm-qt5-3.so which we want to
	# avoid, since we only really link against our mock one, not the system one.
	dh_shlibdeps -XlibMockAccountsService-qml.so -Lliblomiri-private0

override_dh_clean:
	rm -Rfv debian/home
	dh_clean

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
